
#include <avr/io.h>
#include <inttypes.h>
#include <pgmspace.h>
#include <avr/sleep.h>

#include <buskoppler.h>
#include <display.h>


#include <lcd.h>


/*******************************************************/
/*                                                     */
/* Definition des Fonts lcd_fnt4:                      */
/*                                                     */
/*******************************************************/

const graphik_typ PROGMEM lcd_fnt4_0x27 = {
  0x04,
  0x05,
  {0x00,  0xC0,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x28 = {
  0x04,
  0x05,
  {0x70,  0x88,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x29 = {
  0x04,
  0x05,
  {0x88,  0x70,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2A = {
  0x04,
  0x05,
  {0x50,  0x20,  0x50,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2B = {
  0x04,
  0x05,
  {0x20,  0x70,  0x20,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2C = {
  0x04,
  0x05,
  {0x08,  0x10,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2D = {
  0x04,
  0x05,
  {0x40,  0x40,  0x40,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2E = {
  0x04,
  0x05,
  {0x00,  0x08,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x2F = {
  0x04,
  0x05,
  {0x18,  0x20,  0xC0,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x30 = {
  0x04,
  0x05,
  {0xF8,  0x88,  0xF8,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x31 = {
  0x04,
  0x05,
  {0x48,  0xF8,  0x08,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x32 = {
  0x04,
  0x05,
  {0xB8,  0xA8,  0xE8,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x33 = {
  0x04,
  0x05,
  {0x88,  0xA8,  0x70,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x34 = {
  0x04,
  0x05,
  {0xE0,  0x38,  0x60,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x35 = {
  0x04,
  0x05,
  {0xE8,  0xA8,  0x90,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x36 = {
  0x04,
  0x05,
  {0x78,  0xA8,  0xB8,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x37 = {
  0x04,
  0x05,
  {0x80,  0x98,  0xE0,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x38 = {
  0x04,
  0x05,
  {0xF8,  0xA8,  0xF8,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x39 = {
  0x04,
  0x05,
  {0xE8,  0xA8,  0xF0,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3A = {
  0x04,
  0x05,
  {0x00,  0x50,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3B = {
  0x04,
  0x05,
  {0x08,  0x50,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3C = {
  0x04,
  0x05,
  {0x20,  0x50,  0x88,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3D = {
  0x04,
  0x05,
  {0x50,  0x50,  0x50,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3E = {
  0x04,
  0x05,
  {0x88,  0x50,  0x20,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x3F = {
  0x04,
  0x05,
  {0x00,  0x00,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_0x41 = {
  0x03,
  0x05,
  {0x00,  0x00,  0x00}
};

const graphik_typ PROGMEM lcd_fnt4_dummy = {
  0x00,
  0x00,
  {0x00}
};

const graphik_ptr PROGMEM fnt4[] = {
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_0x27,
  &lcd_fnt4_0x28,  &lcd_fnt4_0x29,  &lcd_fnt4_0x2A,  &lcd_fnt4_0x2B,
  &lcd_fnt4_0x2C,  &lcd_fnt4_0x2D,  &lcd_fnt4_0x2E,  &lcd_fnt4_0x2F,
  &lcd_fnt4_0x30,  &lcd_fnt4_0x31,  &lcd_fnt4_0x32,  &lcd_fnt4_0x33,
  &lcd_fnt4_0x34,  &lcd_fnt4_0x35,  &lcd_fnt4_0x36,  &lcd_fnt4_0x37,
  &lcd_fnt4_0x38,  &lcd_fnt4_0x39,  &lcd_fnt4_0x3A,  &lcd_fnt4_0x3B,
  &lcd_fnt4_0x3C,  &lcd_fnt4_0x3D,  &lcd_fnt4_0x3E,  &lcd_fnt4_0x3F,
  &lcd_fnt4_dummy, &lcd_fnt4_0x41,  &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy,
  &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy, &lcd_fnt4_dummy

};

