
/************************************************************************/
/*
/* Scheduler.h
/*
/************************************************************************/


/************************************************************************/
/*
/* Listen der verwendeten ffentlichen Funktionen:
/*
/************************************************************************/

/************************************************************************/
/*
/* Aufbau einer msg:
/*
/* Adresse: TXBnSIDH TXBnSIDL TXBnEIDH TXBnEIDH
/*          BBBBBBBB FFFx1xFF FFFRRRRR bbbbbbbb
/*
/* B[0..7]: Buskoppler-Adresse des Receivers (1..255) (0: Broadcast)
/* R[0..4]: Modul-Adresse des Receivers (1..31) (0: Buskoppler-Modul-Adr.)
/* b[0..7]: Buskoppler-Adresse des Transmitters (1..255)
/* F[0..7]: Funktions-Maske
/*
/* Funktions-Bits:
/* F[0]:    Taster
/* F[1]:    Temperatur
/* F[2]:
/* F[3]:    reserved
/* F[4]:    reserved
/* F[5]:    Multimedia (Broadast)
/* F[6]:    Bus-Control (Broadcast)
/* F[7]:    Buskoppler-Programmierung
/*
/* Broadcast:
/*
/* Datenfelder:
/*
/************************************************************************/

#define key_pressed		1
#define key_long_pressed	2
#define key_released		3
#define key_long_released	4

#define key_up_diff		0
#define	key_down_diff		4
#define	key_switch_diff		8

#define key_down_pressed	key_pressed+key_down_diff		//5
#define key_down_long_pressed	key_long_pressed+key_down_diff		//6
#define key_down_released	key_released+key_down_diff		//7
#define key_down_long_released	key_long_released+key_down_diff		//8

#define key_switch_pressed	key_pressed+key_switch_diff		//9
#define key_switch_long_pressed	key_long_pressed+key_switch_diff   	//10
#define key_switch_released	key_released+key_switch_diff		//11
#define key_switch_long_released key_long_released+key_switch_diff	//12


/************************************************************************/
/*
/*
/*
/************************************************************************/

#define module_anz 		32

typedef struct module_var_typ{
  uint8_t state;
  uint8_t last_state;
  uint8_t timer;	// 50Hz-Timer
  uint8_t sek;		// Sekunden-Timer
} module_var_typ;

typedef struct module_parm_typ {
  uint8_t typ;
  uint8_t hw_nr;
  uint8_t parm1;
  uint8_t parm2;
  uint8_t parm3;
  uint8_t parm4;
  uint8_t parm5;
  uint8_t parm6;
  uint8_t parm7;
  uint8_t parm8;
  uint8_t parm9;
  uint8_t parm10;
  uint8_t parm11;
  uint8_t parm12;
  can_adress_typ adr[12];
  module_var_typ *var;		// 64 Byte gesamt
} module_parm_typ;


/************************************************************************/
/*
/*
/*
/************************************************************************/

#define typ_not_assigned	0

#define nothing_typ		1
#define taster_up_typ 		2
#define taster_down_typ 	3
#define taster_switch_typ	4
#define relais_typ		5
#define jalousie_typ		6
#define dimmer_typ		7


typedef void (*init_function_typ)(const module_parm_typ *my_module);
typedef void (*timer_function_typ)(const module_parm_typ *my_module);
typedef void (*msg_function_typ)(const module_parm_typ *my_module, can_msg_typ *my_msg);


/************************************************************************/
/*
/*
/*
/************************************************************************/

void send_byte_msg(const module_parm_typ *my_module, uint8_t action);

void send_str_msg(const module_parm_typ *my_module, uint8_t *str_ptr);

void scheduler(void);


// End of file

