
#include <avr/io.h>
#include <inttypes.h>
#include <pgmspace.h>
#include <avr/sleep.h>

#include <can.h>
#include <scheduler.h>


// #define BUSKOPPLER_NR 1	// Relais-Modul Ost, Jalousien
#define BUSKOPPLER_NR 2	// Relais-Modul Ost, Licht
// #define BUSKOPPLER_NR 3	// Relais-Modul West, Jalousien + Licht
// #define BUSKOPPLER_NR 4	// Schalter Franka, Gang
// #define BUSKOPPLER_NR 5	// Schalter Lennart, Gang
// #define BUSKOPPLER_NR 6	// Schalter Bad oben
// #define BUSKOPPLER_NR 7	// Schalter Luis
// #define BUSKOPPLER_NR 8	// Schalter Schlafzimmer / Flur / Dusche
// #define BUSKOPPLER_NR 9	// Schalter Wohzimmer Eingang: Jalousien gemeinsam


/************************************************************************/
/*
/*
/*
/************************************************************************/

module_var_typ module_var[module_anz];

uint8_t buskoppler_adress = BUSKOPPLER_NR;


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if (BUSKOPPLER_NR == 1)

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {jalousie_typ,  0, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[0]},	// 0:  Jalousie Bro Eckfenster links
  {jalousie_typ,  2, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[1]},	// 1:  Jalousie Bro Eckfenster rechts
  {jalousie_typ,  4, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[2]},	// 2:  Jalousie Bro Tr
  {jalousie_typ,  6, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[3]},	// 3:  Jalousie Gastezimmer
  {jalousie_typ,  8, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[4]},	// 4:  Jalousie Werkstatt
  {jalousie_typ, 10, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[5]},	// 5:  Jalousie Esszimmer oben
  {jalousie_typ, 12, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[6]},	/// 6:  Fenster !!!!  Esszimmer
  {jalousie_typ, 14, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[7]},	// 7:  Jalousie Esszimmer unten links (Tre)
  {jalousie_typ, 16, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[8]},	// 8:  Jalousie Esszimmer unten rechts
  {jalousie_typ, 18, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[9]},	// 9:  Jalousie Kche Eckfenster links
  {jalousie_typ, 20, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[10]},// 10: Jalousie Kche Eckfenster rechts
  {jalousie_typ, 22, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[11]}	// 11: Jalousie Wohnzimmer Sd

  ,
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  5, 1},
  							      {1, 0,  7, 1},
  							      {1, 0,  8, 1},
  							      {1, 0,  9, 1},
  							      {1, 0, 10, 1},
  							      {1, 0, 11, 1},
  							      {2, 0,  0, 1}}, &module_var[12]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  5, 1},
  							      {1, 0,  7, 1},
  							      {1, 0,  8, 1},
  							      {1, 0,  9, 1},
  							      {1, 0, 10, 1},
  							      {1, 0, 11, 1},
  							      {2, 0,  0, 1}}, &module_var[13]},
  {taster_up_typ,    6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  6, 1}}, &module_var[14]},
  {taster_down_typ,  7, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  6, 1}}, &module_var[15]}

};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 2

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {jalousie_typ,  8, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[0]},	// 0:  Jalousie Wohnzimmer West/Terassentr
  {relais_typ,    0, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[1]},	// 1:  Licht Kche Deckenstrahler
  {relais_typ,    1, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[2]},	// 2:  Licht Kchentisch
  {relais_typ,   10, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[3]},	// 3:  Licht Wohnzimmer Wandlampe
  {relais_typ,    3, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[4]},	// 4:  Licht Wohnzimmer Essbereich
  {relais_typ,    4, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[5]},	// 5:  Licht Wohnzimmer Deckenstrahler
  {relais_typ,    5, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[6]},	// 6:  Licht Speisekammer
  {relais_typ,    6, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[7]},	// 7:  Licht Flur Eingangsbereich
  {relais_typ,    7, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[8]},	// 8:  Licht Boulderraum
  {relais_typ,   11, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[9]}	// 8:  Licht Bro optional
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 3

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {jalousie_typ,  0, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[0]},	// 0:  Jalousie Schlafzimmer
  {jalousie_typ,  2, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[1]},	// 1:  Jalousie Dusche
  {jalousie_typ,  4, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[2]},	// 2:  Jalousie Luis links
  {jalousie_typ,  6, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[3]},	// 3:  Jalousie Luis rechts
  {jalousie_typ,  8, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[4]},	// 4:  Jalousie Lennart
  {jalousie_typ, 10, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[5]},	// 5:  Jalousie Bad
  {jalousie_typ, 12, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[6]},	// 6:  Jalousie Franka links
  {jalousie_typ, 14, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[7]},	// 7:  Jalousie Franka rechts
  {relais_typ,   16, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[8]},	// 8:  Licht Flur unten
  {relais_typ,   17, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[9]},	// 9:  Licht Schlafzimmer
  {relais_typ,   18, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[10]},// 10: Licht Dusche
  {relais_typ,   19, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[11]},// 11: Licht Luis
  {relais_typ,   20, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[12]},// 12: Licht Flur oben
  {relais_typ,   21, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[13]},// 13: Licht Lennart
  {relais_typ,   22, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[14]},// 14: Licht Bad
  {relais_typ,   23, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[15]}	// 15: Licht Franka
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 4	// Lichtschalter Franka

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  6, 4}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  6, 4}}, &module_var[1]},
  {taster_up_typ,    2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  7, 4}}, &module_var[2]},
  {taster_down_typ,  3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  7, 4}}, &module_var[3]},
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 15, 4}}, &module_var[4]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 15, 4}}, &module_var[5]},
  {taster_switch_typ,6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 12, 4}}, &module_var[6]} //,
  // {taster_switch_typ,7, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 20, 4}}, &module_var[7]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 5	// Lichtschalter Lennart

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  4, 5}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  4, 5}}, &module_var[1]},
  {taster_up_typ,    2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 13, 5}}, &module_var[2]},
  {taster_down_typ,  3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 13, 5}}, &module_var[3]},
  {taster_switch_typ,4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 12, 5}}, &module_var[4]} //,
  // {taster_switch_typ,5, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 20, 5}}, &module_var[5]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 6	// Lichtschalter Bad oben

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  5, 6}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  5, 6}}, &module_var[1]},
  {nothing_typ,      2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {},              &module_var[2]},
  {nothing_typ,      3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {},              &module_var[3]},
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 14, 6}}, &module_var[4]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 14, 6}}, &module_var[5]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 7	// Lichtschalter Luis

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  2, 7}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  2, 7}}, &module_var[1]},
  {taster_up_typ,    2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  3, 7}}, &module_var[2]},
  {taster_down_typ,  3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  3, 7}}, &module_var[3]},
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 11, 7}}, &module_var[4]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 11, 7}}, &module_var[5]},
  {taster_switch_typ,6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  8, 7}}, &module_var[6]} //,
  // {taster_switch_typ,7, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 20, 4}}, &module_var[7]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 8	// Lichtschalter Schlafzimmer / Flur unten / Dusche aussen

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  0, 8}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  0, 8}}, &module_var[1]},
  {taster_up_typ,    2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  9, 8}}, &module_var[2]},
  {taster_down_typ,  3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  9, 8}}, &module_var[3]},
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 10, 8}}, &module_var[4]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, 10, 8}}, &module_var[5]},
  {taster_switch_typ,6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0,  8, 8}}, &module_var[6]} //,
  // {taster_switch_typ,5, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{3, 0, xx, 8}}, &module_var[5]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 9	//Jalousieschalter Wozi Eingang

const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,    0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{2, 0,  5, 9}}, &module_var[0]},
  {taster_down_typ,  1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{2, 0,  5, 9}}, &module_var[1]},
  {taster_up_typ,    2, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{2, 0,  3, 9}}, &module_var[2]},
  {taster_down_typ,  3, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{2, 0,  3, 9}}, &module_var[3]},
  {taster_up_typ,    4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  5, 9},
  							      {1, 0,  7, 9},
  							      {1, 0,  8, 9},
  							      {1, 0,  9, 9},
  							      {1, 0, 10, 9},
  							      {1, 0, 11, 9},
  							      {2, 0,  0, 9}}, &module_var[4]},
  {taster_down_typ,  5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  5, 9},
  							      {1, 0,  7, 9},
  							      {1, 0,  8, 9},
  							      {1, 0,  9, 9},
  							      {1, 0, 10, 9},
  							      {1, 0, 11, 9},
  							      {2, 0,  0, 9}}, &module_var[5]},
  {taster_up_typ,    6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  6, 9}}, &module_var[6]},
  {taster_down_typ,  7, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,  6, 9}}, &module_var[7]}
};

#endif


/************************************************************************/
/*
/*
/*
/************************************************************************/

#if BUSKOPPLER_NR == 255

   const module_parm_typ module_parm[module_anz] __attribute__ ((section (".ftext"))) = {
  {taster_up_typ,   4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  {{1, 0, 8, 1}, {1, 0, 9, 1}, {1, 0,10, 1}, {1, 0,11, 1}, {1, 0,12, 1}}, &module_var[0]},
  {taster_down_typ, 5, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  {{1, 0, 8, 1}, {1, 0, 9, 1}, {1, 0,10, 1}, {1, 0,11, 1}, {1, 0,12, 1}}, &module_var[1]},
  {taster_up_typ,   6, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  {{1, 0,13, 1}, {1, 0,14, 1}, {1, 0,15, 1}, {1, 0,16, 1}, {1, 0,17, 1}, {1, 0,18, 1}, {1, 0,19, 1}}, &module_var[2]},
  {taster_down_typ, 7, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  {{1, 0,13, 1}, {1, 0,14, 1}, {1, 0,15, 1}, {1, 0,16, 1}, {1, 0,17, 1}, {1, 0,18, 1}, {1, 0,19, 1}}, &module_var[3]},

  {dimmer_typ},
  {dimmer_typ},
  {dimmer_typ},
  {dimmer_typ},

/*
  {1, 4, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0, 8, 1}, {1, 0, 9, 1},
                                               {1, 0,10, 1}, {1, 0,11, 1},
                                               {1, 0,12, 1}, {1, 0,13, 1},
                                               {1, 0,14, 1}, {1, 0,15, 1}}, &module_var[4]},
  {2, 5, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0, 8, 1}, {1, 0, 9, 1},
                                               {1, 0,10, 1}, {1, 0,11, 1},
                                               {1, 0,12, 1}, {1, 0,13, 1},
                                               {1, 0,14, 1}, {1, 0,15, 1}}, &module_var[5]},
  {1, 6, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,16, 1}, {1, 0,17, 1},
                                               {1, 0,18, 1}, {1, 0,19, 1}}, &module_var[6]},
  {2, 7, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {{1, 0,16, 1}, {1, 0,17, 1},
                                               {1, 0,18, 1}, {1, 0,19, 1}}, &module_var[7]},
*/
  {5, 0, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[8]},
  {5, 2, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[9]},
  {5, 4, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[10]},
  {5, 6, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[11]},
  {5, 8, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[12]},
  {5,10, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[13]},
  {5,12, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[14]},
  {5,14, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[15]},
  {5,16, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[16]},
  {5,18, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[17]},
  {5,20, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[18]},
  {5,22, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[19]}

/*
  ,
  {4,12, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[20]},
  {4,13, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[21]},
  {4,14, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[22]},
  {4,15, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[23]},
  {4,16, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[24]},
  {4,17, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[25]},
  {4,18, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[26]},
  {4,19, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[27]},
  {4,20, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[28]},
  {4,21, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[29]},
  {4,22, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[30]},
  {4,23, 50, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, {}, &module_var[31]}
*/
};

#endif


